## libsbml 5.19.7+dfsg

=== CMakeLists.txt ===
###############################################################################
#
# Description       : CMake build script for libSBML
# Original author(s): Frank Bergmann <fbergman@caltech.edu>
# Organization      : California Institute of Technology
#
# This file is part of libSBML.  Please visit http://sbml.org for more
# information about SBML, and the latest version of libSBML.
#
# Copyright (C) 2013-2017 jointly by the following organizations:
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
#     3. University of Heidelberg, Heidelberg, Germany
#
# Copyright (C) 2009-2013 jointly by the following organizations:
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
#
# Copyright (C) 2006-2008 by the California Institute of Technology,
#     Pasadena, CA, USA
#
# Copyright (C) 2002-2005 jointly by the following organizations:
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. Japan Science and Technology Agency, Japan
#
# This library is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation.  A copy of the license agreement is provided
# in the file named "LICENSE.txt" included with this software distribution
# and also available online as http://sbml.org/software/libsbml/license.html
#
###############################################################################

cmake_minimum_required(VERSION 2.8.12...3.19)
project(libsbml)

set(LIBSBML_ROOT_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}" CACHE PATH
    "Path to the libSBML root source directory")
set(LIBSBML_ROOT_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}" CACHE PATH
    "Path to the libSBML root build directory")

include (CMakeTestCCompiler)
include (CheckCSourceCompiles)
include (CheckCXXSourceCompiles)
include (CheckStructHasMember)
include (CheckLibraryExists)
include (CheckFunctionExists)
include (CheckCCompilerFlag)
include (CheckCSourceRuns)
include (CheckSymbolExists)
include (CheckTypeSize)
if (${CMAKE_VERSION} VERSION_GREATER 2.8.4)
	include(GNUInstallDirs)
else ()
	set (CMAKE_INSTALL_DATADIR "share/libsbml/")
	set (CMAKE_INSTALL_LIBDIR "lib")
	set (CMAKE_INSTALL_INCLUDEDIR "include")
	set (CMAKE_INSTALL_BINDIR "bin")
	set (CMAKE_INSTALL_DATADIR "share")
	set (CMAKE_INSTALL_FULL_LIBDIR "${CMAKE_INSTALL_PREFIX}/lib")
	set (CMAKE_INSTALL_FULL_INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include")
endif ()

###############################################################################
#
# Parse VERSION.txt to determine the package version
#

set(LIBSBML_VERSION_MAJOR)
set(LIBSBML_VERSION_MINOR)
set(LIBSBML_VERSION_PATCH)
set(LIBSBML_VERSION_RELEASE)
set(LIBSBML_DOTTED_VERSION)

if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/VERSION.txt")

    file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/VERSION.txt" VersionString NEWLINE_CONSUME)
    string(STRIP "${VersionString}" VersionString)
    set(LIBSBML_DOTTED_VERSION ${VersionString})
    string(REPLACE "." ";" VersionString "${VersionString}" )
    string(REPLACE "-" ";" VersionString "${VersionString}" )
    list(LENGTH VersionString versionLength)
    list(GET VersionString 0 LIBSBML_VERSION_MAJOR )
    list(GET VersionString 1 LIBSBML_VERSION_MINOR )
    list(GET VersionString 2 LIBSBML_VERSION_PATCH )

    if(${versionLength} GREATER 3)
        list(GET VersionString 3 LIBSBML_VERSION_RELEASE )
    endif()

endif()

# version number needs to be calculated correctly
MATH(EXPR LIBSBML_VERSION_NUMERIC "${LIBSBML_VERSION_MAJOR} * 10000 + ${LIBSBML_VERSION_MINOR} * 100 + ${LIBSBML_VERSION_PATCH}" )
set(PACKAGE_VERSION "${LIBSBML_VERSION_MAJOR}.${LIBSBML_VERSION_MINOR}.${LIBSBML_VERSION_PATCH}${LIBSBML_VERSION_RELEASE}")
set(PACKAGE_NAME "libSBML")

set(PACKAGE_CONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/cmake" CACHE PATH
    "Path into which the cmake config files should be installed")


# PACKAGE_VERSION gets overridden by using other packages, so setting
# the PROJECT_VERSION, which will be used when exporting targets in
# src/CMakeLists.txt
set(PROJECT_VERSION ${PACKAGE_VERSION})

if (WITH_DOXYGEN OR WITH_PYTHON)
  # configure the version for documentation / bindings
  configure_file(
      ${CMAKE_CURRENT_SOURCE_DIR}/docs/src/common-text/libsbml-version.html.in
      ${CMAKE_CURRENT_SOURCE_DIR}/docs/src/common-text/libsbml-version.html
  )
endif()

# add make dist and make check target as they are already familiar for
# everyone using the gnumake build
add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
add_custom_target(check COMMAND ${CMAKE_MAKE_PROGRAM} test)

###############################################################################
#
# The next lines configure the parameters for packaging the binaries.
# They can be invoked with "make package" or "nmake package" or by using
# cpack -G zip|deb|rpm|dmg|nsis
#

set(CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_NO_WARNINGS ON)
include(InstallRequiredSystemLibraries)

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "An API library for reading/writing/manipulating SBML.")
set(CPACK_PACKAGE_NAME "${PACKAGE_NAME}")
set(CPACK_PACKAGE_VENDOR "The libSBML Team")
set(CPACK_PACKAGE_CONTACT "LibSBML Team <libsbml-team@googlegroups.com>")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING.txt")
set(CPACK_PACKAGE_VERSION_MAJOR "${LIBSBML_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${LIBSBML_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${LIBSBML_VERSION_PATCH}")
set(CPACK_RPM_PACKAGE_LICENSE "LGPL")
set(CPACK_RPM_PACKAGE_GROUP "Libraries/Development")
set(CPACK_DEBIAN_PACKAGE_SECTION "Libraries")

set(CPACK_SOURCE_IGNORE_FILES "${CMAKE_CURRENT_BINARY_DIR};/.vs/;/.vscode/;/.svn/;/.libs/;/.deps/;/.bzr/;.*.o$;.*.lo$;.*.la$;${CPACK_SOURCE_IGNORE_FILES};/.DS_Store;/.svnignore;blib;libsbml-dist")

if(UNIX)
    set(CPACK_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
    set(CPACK_SET_DESTDIR "ON")
endif()

if(CMAKE_SIZEOF_VOID_P EQUAL 4)
    set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "i386")
    set(CPACK_RPM_PACKAGE_ARCHITECTURE "i386")
else()
    set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "amd64")
    set(CPACK_RPM_PACKAGE_ARCHITECTURE "x86_64")
endif()

include(CPack)


# add local modules to module path
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")

# install find modules, so they can readily be used by others: start with libSBML
set (LIBSBML_FIND_MODULES "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/FindLIBSBML.cmake")


###############################################################################
#
# Here we have the main configuration options for libsbml.
#

# Build static / shared library
# option(BUILD_SHARED_LIBS  "Build shared library. (Set to OFF to build static libraries.)" OFF)

# Whether to compile examples
option(WITH_EXAMPLES "Compile the libSBML example programs."  OFF)

# Which language bindings should be built
option(WITH_CSHARP   "Generate the C# language interface for libSBML."     OFF)
option(WITH_JAVA     "Generate the Java language interface for libSBML."   OFF)
option(WITH_PYTHON   "Generate the Python language interface for libSBML." OFF)
option(WITH_PERL     "Generate the Perl language interface for libSBML."   OFF)
option(WITH_PHP      "Generate the PHP language interface for libSBML."    OFF)
option(WITH_RUBY     "Generate the Ruby language interface for libSBML"    OFF)
option(WITH_R        "Generate the R language interface for libSBML"       OFF)
option(WITH_OCTAVE   "Generate the Octave language interface for libSBML." OFF)
option(WITH_MATLAB   "Generate the MATLAB language interface for libSBML." OFF)
option(WITH_JAVASCRIPT      "Generate the experimental Node.js language interface for libSBML." OFF)
option(WITH_STABLE_PACKAGES "Compile libSBML with all stable packages." OFF)
option(WITH_ALL_PACKAGES    "Compile libSBML with all packages." OFF)

if (WITH_ALL_PACKAGES)
  set(_EXPERIMENTAL_PACKGES "arrays;dyn;spatial;REQUIREDELEMENTS")
  foreach(package ${_EXPERIMENTAL_PACKGES})
    string(TOUPPER ${package} package_upper)
    string(CONCAT package_option "ENABLE_" ${package_upper})
    set(${package_option} ON CACHE BOOL "Enable package" FORCE)
  endforeach()
  set(WITH_STABLE_PACKAGES ON CACHE BOOL "Enable stable packages" FORCE)
endif(WITH_ALL_PACKAGES)

if (WITH_STABLE_PACKAGES)
  set(_STABLE_PACKGES "comp;distrib;fbc;groups;layout;multi;qual;render")
  foreach(package ${_STABLE_PACKGES})
    string(TOUPPER ${package} package_upper)
    string(CONCAT package_option "ENABLE_" ${package_upper})
    set(${package_option} ON CACHE BOOL "Enable package" FORCE)
  endforeach()
endif(WITH_STABLE_PACKAGES)

if (WITH_JAVASCRIPT)

  set(_PF86 "ProgramFiles(x86)")
  find_program(NODE_GYP_EXECUTABLE
        NAMES node-gyp node-gyp.cmd
        PATHS
              /usr/local/bin
              /opt/local/bin
              /usr/bin
              "$ENV{ProgramFilesProgramFiles}/nodejs/"
              "$ENV{ProgramW6432}/nodejs/"
        DOC "The file name of the node-gyp executable."
        )

  find_program(NODEJS_EXECUTABLE
        NAMES node nodeexe
        PATHS
              /usr/local/bin
              /opt/local/bin
              /usr/bin
              "$ENV{ProgramFiles}/nodejs/"
              "$ENV{ProgramW6432}/nodejs/"
        DOC "The file name of the nodejs executable."
        )
  # check that we found node-gyp
  if (NOT NODE_GYP_EXECUTABLE)
        message(FATAL_ERROR
"In oder to build the JavaScript language interface, libSBML needs the
node-gyp executable. Please set the variable named NODE_GYP_EXECUTABLE.")
  endif()

  # ensure that the swig version is high enough for javascript
  if (SWIG_VERSION AND NOT SWIG_VERSION VERSION_GREATER 3.0.1)
        message(FATAL_ERROR
"SWIG version 3.0.2 or greater is needed in order to build the JavaScript
language interface for libSBML, but only version ${SWIG_VERSION} was found.")
  endif()

endif()

# Add an option to compile with all warnings shown
option(WITH_WALL     "Compile with -Wall, so that the compiler will display all warnings." OFF)
mark_as_advanced(WITH_WALL)

if(WITH_WALL)
    if(MSVC OR USING_INTEL)
        add_definitions(/W4)
        string(REPLACE "/W3" "/W4" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
        string(REPLACE "/W3" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    else()
        add_definitions(-Wall)
    endif()
endif()

# Add an option to instruct libSBML to not include SBMLTypes.h and other files internally.
option(LIBSBML_USE_STRICT_INCLUDES
"Compile using 'strict includes' rules: libSBML header files won't
use SBMLTypes.h, among others." OFF)
if(LIBSBML_USE_STRICT_INCLUDES)
  add_definitions(-DLIBSBML_USE_STRICT_INCLUDES)
endif(LIBSBML_USE_STRICT_INCLUDES)
mark_as_advanced(LIBSBML_USE_STRICT_INCLUDES)

set(LIBSBML_BUILD_TYPE "native")
if (CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(LIBSBML_BUILD_TYPE "32bit")
else()
  set(LIBSBML_BUILD_TYPE "64bit")
endif()
if (APPLE AND ENABLE_UNIVERSAL)
  set(LIBSBML_BUILD_TYPE "universal")
endif()

# When allocation of memory fails or the libSBML C API is unable to open
# a file, libSBML can exit the current process. By default this behavior
# is disabled.
#
option (EXIT_ON_ERROR "Call exit(-1) in case of allocation or file error." OFF)
mark_as_advanced(EXIT_ON_ERROR)

# Use the version number in the shared library.
#
option (LIBSBML_SHARED_VERSION
"Include version information into the compiled libSBML shared library." ON)
mark_as_advanced(LIBSBML_SHARED_VERSION)

# initial value for xml2 parser will default to ON, 
# unless expat or xerces are chosen
set(WITH_LIBXML_INITIAL ON)
if (WITH_EXPAT OR WITH_XERCES)
set(WITH_LIBXML_INITIAL OFF)
endif()

# Choose the xml parsing library to be used.
option(WITH_EXPAT    "Use the Expat XML parser library."     OFF)

=== examples/c++/CMakeLists.txt ===
## @file    CMakeLists.txt
## @brief   CMake build script for example programs
## @author  Frank T. Bergmann
##
## <!--------------------------------------------------------------------------
## This file is part of libSBML.  Please visit http://sbml.org for more
## information about SBML, and the latest version of libSBML.
##
## Copyright (C) 2013-2018 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##     3. University of Heidelberg, Heidelberg, Germany
##
## Copyright (C) 2009-2013 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##
## Copyright (C) 2006-2008 by the California Institute of Technology,
##     Pasadena, CA, USA
##
## Copyright (C) 2002-2005 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. Japan Science and Technology Agency, Japan
##
## This library is free software; you can redistribute it and/or modify it
## under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation.  A copy of the license agreement is provided
## in the file named "LICENSE.txt" included with this software distribution
## and also available online as http://sbml.org/software/libsbml/license.html
## ------------------------------------------------------------------------ -->

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(BEFORE ${LIBSBML_ROOT_SOURCE_DIR}/src)
include_directories(${LIBSBML_ROOT_SOURCE_DIR}/include)
include_directories(BEFORE ${LIBSBML_ROOT_BINARY_DIR}/src)


if (EXTRA_INCLUDE_DIRS)
include_directories(${EXTRA_INCLUDE_DIRS})
endif(EXTRA_INCLUDE_DIRS)

foreach(example

    addCVTerms
    addCustomValidator
    addingEvidenceCodes_1
    addingEvidenceCodes_2
    addModelHistory
    appendAnnotation
    callExternalValidator
    convertSBML
    convertToL1V1
    createExampleSBML
    echoSBML
    inferUnits
    inlineFunctionDefintions
    convertReactions
    getAllElementsWithNotes
    printAnnotation
    printMath
    printNotes
    printSBML
    printRegisteredPackages
    printSupported
    printUnits
    promoteParameters
    readSBML
    renameSId
    setIdFromNames
    setNamesFromIds
    stripPackage
    translateMath
    translateL3Math
    unsetAnnotation
    unsetNotes
    validateSBML

)
    add_executable(example_cpp_${example} ${example}.cpp util.c)
    set_target_properties(example_cpp_${example} PROPERTIES  OUTPUT_NAME ${example})
    target_link_libraries(example_cpp_${example} ${LIBSBML_LIBRARY}-static)

endforeach()

if (WITH_LIBXML)
  add_executable(example_cpp_rngvalidator rngvalidator.cpp util.c)
  set_target_properties(example_cpp_rngvalidator PROPERTIES  OUTPUT_NAME rngvalidator)
  target_link_libraries(example_cpp_rngvalidator ${LIBSBML_LIBRARY}-static)
  target_link_libraries(example_cpp_rngvalidator LIBXML::LIBXML ${EXTRA_LIBS})
endif()

# run examples as test

add_test(NAME test_cxx_addCVTerms
         COMMAND "$<TARGET_FILE:example_cpp_addCVTerms>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         addCVTerms.out.xml
)
add_test(NAME test_cxx_addCustomValidator
         COMMAND "$<TARGET_FILE:example_cpp_addCustomValidator>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml

)
add_test(NAME test_cxx_addingEvidenceCodes_1
         COMMAND "$<TARGET_FILE:example_cpp_addingEvidenceCodes_1>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         addingEvidenceCodes_1.out.xml
)
add_test(NAME test_cxx_addingEvidenceCodes_2
         COMMAND "$<TARGET_FILE:example_cpp_addingEvidenceCodes_2>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         addingEvidenceCodes_2.out.xml
)
add_test(NAME test_cxx_addModelHistory
         COMMAND "$<TARGET_FILE:example_cpp_addModelHistory>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         addModelHistory.out.xml
)
add_test(NAME test_cxx_appendAnnotation
         COMMAND "$<TARGET_FILE:example_cpp_appendAnnotation>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         appendAnnotation.out.xml
)
add_test(NAME test_cxx_callExternalValidator
         COMMAND "$<TARGET_FILE:example_cpp_callExternalValidator>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         callExternalValidator.out.xml
)
add_test(NAME test_cxx_convertSBML
         COMMAND "$<TARGET_FILE:example_cpp_convertSBML>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         convertSBML.out.xml
)
add_test(NAME test_cxx_convertToL1V1
         COMMAND "$<TARGET_FILE:example_cpp_convertToL1V1>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         convertToL1V1.out.xml
)
add_test(NAME test_cxx_createExampleSBML
         COMMAND "$<TARGET_FILE:example_cpp_createExampleSBML>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         createExampleSBML.out.xml
)
add_test(NAME test_cxx_echoSBML
         COMMAND "$<TARGET_FILE:example_cpp_echoSBML>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         echoSBML.out.xml
)
add_test(NAME test_cxx_inferUnits
         COMMAND "$<TARGET_FILE:example_cpp_inferUnits>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         inferUnits.out.xml
)
add_test(NAME test_cxx_inlineFunctionDefintions
         COMMAND "$<TARGET_FILE:example_cpp_inlineFunctionDefintions>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         inlineFunctionDefintions.out.xml
)
add_test(NAME test_cxx_convertReactions
         COMMAND "$<TARGET_FILE:example_cpp_convertReactions>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         convertReactions.out.xml
)
add_test(NAME test_cxx_getAllElementsWithNotes
         COMMAND "$<TARGET_FILE:example_cpp_getAllElementsWithNotes>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)
add_test(NAME test_cxx_printAnnotation
         COMMAND "$<TARGET_FILE:example_cpp_printAnnotation>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)
add_test(NAME test_cxx_printMath
         COMMAND "$<TARGET_FILE:example_cpp_printMath>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)
add_test(NAME test_cxx_printNotes
         COMMAND "$<TARGET_FILE:example_cpp_printNotes>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)
add_test(NAME test_cxx_printSBML
         COMMAND "$<TARGET_FILE:example_cpp_printSBML>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)
add_test(NAME test_cxx_printRegisteredPackages
         COMMAND "$<TARGET_FILE:example_cpp_printRegisteredPackages>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         printRegisteredPackages.out.xml
)
add_test(NAME test_cxx_printSupported
         COMMAND "$<TARGET_FILE:example_cpp_printSupported>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         printSupported.out.xml
)
add_test(NAME test_cxx_printUnits
         COMMAND "$<TARGET_FILE:example_cpp_printUnits>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)
add_test(NAME test_cxx_promoteParameters
         COMMAND "$<TARGET_FILE:example_cpp_promoteParameters>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         promoteParameters.out.xml
)
add_test(NAME test_cxx_readSBML
         COMMAND "$<TARGET_FILE:example_cpp_readSBML>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)
add_test(NAME test_cxx_renameSId
         COMMAND "$<TARGET_FILE:example_cpp_renameSId>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         veq
         veqnew
         renameSId.out.xml
)
add_test(NAME test_cxx_setIdFromNames
         COMMAND "$<TARGET_FILE:example_cpp_setIdFromNames>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         setIdFromNames.out.xml
)
add_test(NAME test_cxx_setNamesFromIds
         COMMAND "$<TARGET_FILE:example_cpp_setNamesFromIds>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         setNamesFromIds.out.xml
)

 if(ENABLE_FBC) 

add_test(NAME test_cxx_stripPackage
         COMMAND "$<TARGET_FILE:example_cpp_stripPackage>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/fbc/fbc_example1.xml
         fbc
         stripPackage.out.xml
)

endif(ENABLE_FBC)

add_test(NAME test_cxx_unsetAnnotation
         COMMAND "$<TARGET_FILE:example_cpp_unsetAnnotation>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         unsetAnnotation.out.xml
)
add_test(NAME test_cxx_unsetNotes
         COMMAND "$<TARGET_FILE:example_cpp_unsetNotes>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         unsetNotes.out.xml
)
add_test(NAME test_cxx_validateSBML
         COMMAND "$<TARGET_FILE:example_cpp_validateSBML>"
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

=== examples/c/CMakeLists.txt ===
## @file    CMakeLists.txt
## @brief   CMake build script for example programs
## @author  Frank T. Bergmann
##
## <!--------------------------------------------------------------------------
## This file is part of libSBML.  Please visit http://sbml.org for more
## information about SBML, and the latest version of libSBML.
##
## Copyright (C) 2013-2018 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##     3. University of Heidelberg, Heidelberg, Germany
##
## Copyright (C) 2009-2013 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##  
## Copyright (C) 2006-2008 by the California Institute of Technology,
##     Pasadena, CA, USA 
##  
## Copyright (C) 2002-2005 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. Japan Science and Technology Agency, Japan
## 
## This library is free software; you can redistribute it and/or modify it
## under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation.  A copy of the license agreement is provided
## in the file named "LICENSE.txt" included with this software distribution
## and also available online as http://sbml.org/software/libsbml/license.html
## ------------------------------------------------------------------------ -->

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(BEFORE ${LIBSBML_ROOT_SOURCE_DIR}/src)
include_directories(${LIBSBML_ROOT_SOURCE_DIR}/include)
include_directories(BEFORE ${LIBSBML_ROOT_BINARY_DIR}/src)

if (EXTRA_INCLUDE_DIRS) 
include_directories(${EXTRA_INCLUDE_DIRS})
endif(EXTRA_INCLUDE_DIRS)

foreach(example 

	addCVTerms
	addingEvidenceCodes_1
	addingEvidenceCodes_2
	addModelHistory
	appendAnnotation
	convertSBML
	createExampleSBML
	drawMath
	echoSBML
	evaluateMath
	printAnnotation
	printMath
	printNotes
	printRegisteredPackages
	printSBML
	printSupported
	printUnits
	promoteParameters
	readSBML
	stripPackage
	translateMath
	translateL3Math
	unsetAnnotation
	unsetNotes
	validateSBML

)
	add_executable(example_c_${example} ${example}.c util.c)
	set_target_properties(example_c_${example} PROPERTIES  OUTPUT_NAME ${example})
	target_link_libraries(example_c_${example} ${LIBSBML_LIBRARY}-static)	

endforeach()

# run examples as test 

add_test(NAME test_c_addCVTerms
         COMMAND "$<TARGET_FILE:example_c_addCVTerms>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         addCVTerms.out.xml
)

add_test(NAME test_c_addingEvidenceCodes_1
         COMMAND "$<TARGET_FILE:example_c_addingEvidenceCodes_1>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         addingEvidenceCodes_1.out.xml
)

add_test(NAME test_c_addingEvidenceCodes_2
         COMMAND "$<TARGET_FILE:example_c_addingEvidenceCodes_2>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         addingEvidenceCodes_2.out.xml
)

add_test(NAME test_c_addModelHistory
         COMMAND "$<TARGET_FILE:example_c_addModelHistory>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         addModelHistory.out.xml
)

add_test(NAME test_c_appendAnnotation
         COMMAND "$<TARGET_FILE:example_c_appendAnnotation>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         appendAnnotation.out.xml
)

add_test(NAME test_c_convertSBML
         COMMAND "$<TARGET_FILE:example_c_convertSBML>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         convertSBML.out.xml
)

add_test(NAME test_c_createExampleSBML
         COMMAND "$<TARGET_FILE:example_c_createExampleSBML>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         createExampleSBML.out.xml
)

add_test(NAME test_c_drawMath
         COMMAND "$<TARGET_FILE:example_c_drawMath>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         drawMath.out.xml
)

add_test(NAME test_c_echoSBML
         COMMAND "$<TARGET_FILE:example_c_echoSBML>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         echoSBML.out.xml
)

add_test(NAME test_c_printAnnotation
         COMMAND "$<TARGET_FILE:example_c_printAnnotation>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

add_test(NAME test_c_printMath
         COMMAND "$<TARGET_FILE:example_c_printMath>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

add_test(NAME test_c_printNotes
         COMMAND "$<TARGET_FILE:example_c_printNotes>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

add_test(NAME test_c_printRegisteredPackages
         COMMAND "$<TARGET_FILE:example_c_printRegisteredPackages>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

add_test(NAME test_c_printSBML
         COMMAND "$<TARGET_FILE:example_c_printSBML>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

add_test(NAME test_c_printSupported
         COMMAND "$<TARGET_FILE:example_c_printSupported>" 
)

add_test(NAME test_c_printUnits
         COMMAND "$<TARGET_FILE:example_c_printUnits>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

add_test(NAME test_c_promoteParameters
         COMMAND "$<TARGET_FILE:example_c_promoteParameters>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         promoteParameters.out.xml
)

add_test(NAME test_c_readSBML
         COMMAND "$<TARGET_FILE:example_c_readSBML>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

 if(ENABLE_FBC) 

add_test(NAME test_c_stripPackage
         COMMAND "$<TARGET_FILE:example_c_stripPackage>" 
		 ${CMAKE_SOURCE_DIR}/examples/sample-models/fbc/fbc_example1.xml
		 fbc
		 stripPackage.out.xml
)

endif(ENABLE_FBC)

add_test(NAME test_c_unsetAnnotation
         COMMAND "$<TARGET_FILE:example_c_unsetAnnotation>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
         unsetAnnotation.out.xml
)

add_test(NAME test_c_unsetNotes
		 COMMAND "$<TARGET_FILE:example_c_unsetNotes>" 
		 ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
		 unsetNotes.out.xml
)

add_test(NAME test_c_validateSBML
         COMMAND "$<TARGET_FILE:example_c_validateSBML>" 
         ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

=== examples/csharp/CMakeLists.txt ===
## @file    CMakeLists.txt
## @brief   CMake build script for example programs
## @author  Frank T. Bergmann
##
## <!--------------------------------------------------------------------------
## This file is part of libSBML.  Please visit http://sbml.org for more
## information about SBML, and the latest version of libSBML.
##
## Copyright (C) 2013-2018 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##     3. University of Heidelberg, Heidelberg, Germany
##
## Copyright (C) 2009-2013 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##
## Copyright (C) 2006-2008 by the California Institute of Technology,
##     Pasadena, CA, USA
##
## Copyright (C) 2002-2005 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. Japan Science and Technology Agency, Japan
##
## This library is free software; you can redistribute it and/or modify it
## under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation.  A copy of the license agreement is provided
## in the file named "LICENSE.txt" included with this software distribution
## and also available online as http://sbml.org/software/libsbml/license.html
## ------------------------------------------------------------------------ -->

foreach( example

    addCustomValidator
    addCVTerms
    addingEvidenceCodes_1
    addingEvidenceCodes_2
    addModelHistory
    appendAnnotation
    callExternalValidator
    convertSBML
    createExampleSBML
    echoSBML
    GetAllElementsWithNotes
    printAnnotation
    printMath
    printNotes
    printRegisteredPackages
    printSBML
    printsupported
    printUnits
    promoteParameters
    readSBML
    stripPackage
    SetIdFromNames
    translateMath
    unsetAnnotation
    unsetNotes
    validateSBML
    evaluateCustomMath
    inlineInitialAssignments
    replaceOneFD

)

    ADD_CUSTOM_COMMAND(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${example}.exe
        COMMAND "${CSHARP_EXAMPLE_COMPILER}"
        ARGS -r:${CMAKE_CURRENT_BINARY_DIR}/../../src/bindings/csharp/libsbmlcsP.dll
            -target:exe
            -out:${example}.exe
            ${CSHARP_EXTRA_ARGS}
            ${CMAKE_CURRENT_SOURCE_DIR}${PATH_SEP}${example}.cs
        MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/${example}.cs
        COMMENT "Build C# example: ${example}")

    add_custom_target(example_cs_${example} ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${example}.exe)
    add_dependencies(example_cs_${example} binding_csharp_managed_lib)
endforeach()



####################################################################
#
# CMake Build Script for C# examples
#

macro(ADJUST_ENVIRONMENT target)

file(TO_NATIVE_PATH $<TARGET_FILE_DIR:binding_csharp_native_lib> CS_PATH)

if (APPLE)
    # adjust DYLD_LIBRARY_PATH
    set_tests_properties(${target} PROPERTIES ENVIRONMENT DYLD_LIBRARY_PATH=${CMAKE_CURRENT_BINARY_DIR}/../:$<TARGET_FILE_DIR:binding_csharp_native_lib>:$ENV{DYLD_LIBRARY_PATH})
elseif(UNIX)
    # adjust LD_LIBRARY_PATH
    set_tests_properties(${target} PROPERTIES ENVIRONMENT LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/src/bindings/csharp/:$<TARGET_FILE_DIR:binding_csharp_native_lib>:$ENV{LD_LIBRARY_PATH})
else()
    # adjust path variable
    SET (NEW_PATH "$<TARGET_FILE_DIR:binding_csharp_native_lib>\\;${CS_PATH}\\;$ENV{PATH}")
    STRING(REPLACE "\\;" ";" NEW_PATH "${NEW_PATH}")
    STRING(REPLACE ";" "\\;" NEW_PATH "${NEW_PATH}")
    set_tests_properties(${target} PROPERTIES ENVIRONMENT PATH=${NEW_PATH})
endif()

endmacro()


set(CS_INTERPRETER)
if (NOT WIN32)
    set(CS_INTERPRETER mono)
endif()

# run examples as test 

if (CMAKE_VERSION VERSION_LESS 3.0)
    message(STATUS "C# example tests check version: ${CMAKE_VERSION} < 3.0, skipping.")
else()

    add_test(NAME test_cs_addCVTerms
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/addCVTerms.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
        addCVTerms.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_addCVTerms)
    
    add_test(NAME test_cs_addingEvidenceCodes_1
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/addingEvidenceCodes_1.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
        addingEvidenceCodes_1.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_addingEvidenceCodes_1)
    
    add_test(NAME test_cs_addingEvidenceCodes_2
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/addingEvidenceCodes_2.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
        addingEvidenceCodes_2.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_addingEvidenceCodes_2)
    
    add_test(NAME test_cs_addModelHistory
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/addModelHistory.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
        addModelHistory.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_addModelHistory)
    
    add_test(NAME test_cs_appendAnnotation
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/appendAnnotation.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
        appendAnnotation.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_appendAnnotation)
    
    add_test(NAME test_cs_convertSBML
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/convertSBML.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
        convertSBML.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_convertSBML)
    
    add_test(NAME test_cs_createExampleSBML
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/createExampleSBML.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
        createExampleSBML.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_createExampleSBML)
    
    add_test(NAME test_cs_echoSBML
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/echoSBML.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
        echoSBML.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_echoSBML)
    
    add_test(NAME test_cs_GetAllElementsWithNotes
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/GetAllElementsWithNotes.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    )
    ADJUST_ENVIRONMENT(test_cs_GetAllElementsWithNotes)
    
    add_test(NAME test_cs_printAnnotation
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/printAnnotation.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    )
    ADJUST_ENVIRONMENT(test_cs_printAnnotation)
    
    add_test(NAME test_cs_printMath
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/printMath.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    )
    ADJUST_ENVIRONMENT(test_cs_printMath)
    
    add_test(NAME test_cs_printNotes
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/printNotes.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    )
    ADJUST_ENVIRONMENT(test_cs_printNotes)
    
    add_test(NAME test_cs_printRegisteredPackages
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/printRegisteredPackages.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
        printRegisteredPackages.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_printRegisteredPackages)
    
    add_test(NAME test_cs_printSBML
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/printSBML.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    )
    ADJUST_ENVIRONMENT(test_cs_printSBML)
    
    add_test(NAME test_cs_printsupported
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/printsupported.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
        printsupported.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_printsupported)
    
    add_test(NAME test_cs_printUnits
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/printUnits.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    )
    ADJUST_ENVIRONMENT(test_cs_printUnits)
    
    add_test(NAME test_cs_promoteParameters
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/promoteParameters.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
        promoteParameters.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_promoteParameters)
    
    add_test(NAME test_cs_readSBML
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/readSBML.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    )
    ADJUST_ENVIRONMENT(test_cs_readSBML)
    
	if(ENABLE_FBC) 

    add_test(NAME test_cs_stripPackage
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/stripPackage.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/fbc/fbc_example1.xml
        fbc
        stripPackage.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_stripPackage)
    
	endif(ENABLE_FBC)

    add_test(NAME test_cs_SetIdFromNames
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/SetIdFromNames.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
        SetIdFromNames.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_SetIdFromNames)
    
    add_test(NAME test_cs_unsetAnnotation
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/unsetAnnotation.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
        unsetAnnotation.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_unsetAnnotation)
    
    add_test(NAME test_cs_unsetNotes
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/unsetNotes.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
        unsetNotes.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_unsetNotes)
    
    add_test(NAME test_cs_validateSBML
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/validateSBML.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    )
    ADJUST_ENVIRONMENT(test_cs_validateSBML)
    
    add_test(NAME test_cs_evaluateCustomMath
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/evaluateCustomMath.exe
        2*3+4
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    )
    ADJUST_ENVIRONMENT(test_cs_evaluateCustomMath)
    
    add_test(NAME test_cs_inlineInitialAssignments
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/inlineInitialAssignments.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
        inlineInitialAssignments.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_inlineInitialAssignments)
    
    add_test(NAME test_cs_replaceOneFD
        COMMAND ${CS_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/replaceOneFD.exe
        ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/functiondef.xml
        f
        reaction_1
        replaceOneFD.out.xml
    )
    ADJUST_ENVIRONMENT(test_cs_replaceOneFD)

endif()

=== examples/java/CMakeLists.txt ===
## @file    CMakeLists.txt
## @brief   CMake build script for example programs
## @author  Frank T. Bergmann
##
## <!--------------------------------------------------------------------------
## This file is part of libSBML.  Please visit http://sbml.org for more
## information about SBML, and the latest version of libSBML.
##
## Copyright (C) 2013-2018 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##     3. University of Heidelberg, Heidelberg, Germany
##
## Copyright (C) 2009-2013 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##  
## Copyright (C) 2006-2008 by the California Institute of Technology,
##     Pasadena, CA, USA 
##  
## Copyright (C) 2002-2005 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. Japan Science and Technology Agency, Japan
## 
## This library is free software; you can redistribute it and/or modify it
## under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation.  A copy of the license agreement is provided
## in the file named "LICENSE.txt" included with this software distribution
## and also available online as http://sbml.org/software/libsbml/license.html
## ------------------------------------------------------------------------ -->

find_package(Java COMPONENTS Development REQUIRED)

file(TO_NATIVE_PATH ${CMAKE_CURRENT_BINARY_DIR} CURRENT_BIN)
file(TO_NATIVE_PATH ${CMAKE_CURRENT_BINARY_DIR}/../../src/bindings/java/libsbmlj.jar CURRENT_JAR )
file(TO_NATIVE_PATH $<TARGET_FILE_DIR:binding_java_lib> LIBRARY_PATH)

if (JAVA_COMPATIBILITY)
SET(COMPAT_ARGS "-source ${JAVA_COMPATIBILITY} -target ${JAVA_COMPATIBILITY}")
endif()

foreach(file 
    addCustomValidator
    addCVTerms
    addingEvidenceCodes_1
    addingEvidenceCodes_2
    addModelHistory
    appendAnnotation
    callExternalValidator
    convertSBML
    createExampleSBML
    echoSBML
    evaluateMath
    getAllElementsWithNotes
    printAnnotation
    printMath
    printNotes
    printRegisteredPackages
    printSBML
    printsupported
    printUnits
    promoteParameters
    readSBML
    stripPackage
    setIdFromNames
    translateMath
    unsetAnnotation
    unsetNotes
    validateSBML
    evaluateCustomMath
    inlineInitialAssignments
    replaceOneFD
    )

file(TO_NATIVE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/${file}.java CURRENT_FILE)

add_custom_command(	
    OUTPUT ${file}.class
    COMMAND "${Java_JAVAC_EXECUTABLE}"
    ARGS -cp ".${FILE_SEP}\"${CURRENT_JAR}\"${FILE_SEP}${CMAKE_CURRENT_SOURCE_DIR}"
        ${CURRENT_FILE}
        ${COMPAT_ARGS}
        -d ${CMAKE_CURRENT_BINARY_DIR}
    MAIN_DEPENDENCY "${CMAKE_CURRENT_SOURCE_DIR}/../../src/bindings/java/local.i"
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${file}.java
    COMMENT "Build java example ${file}"
) 

add_custom_target(example_java_${file} ALL 
    DEPENDS 
    ${CMAKE_CURRENT_BINARY_DIR}/${file}.class 
    SOURCES 
    ${CMAKE_CURRENT_SOURCE_DIR}/${file}.java 
)

add_dependencies(example_java_${file} binding_java_jar)

endforeach()

# run examples as test 

add_test(NAME test_java_addCVTerms
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    addCVTerms
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    addCVTerms.out.xml
)

add_test(NAME test_java_addingEvidenceCodes_1
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    addingEvidenceCodes_1
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    addingEvidenceCodes_1.out.xml
)

add_test(NAME test_java_addingEvidenceCodes_2
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    addingEvidenceCodes_2
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    addingEvidenceCodes_2.out.xml
)

add_test(NAME test_java_addModelHistory
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    addModelHistory
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    addModelHistory.out.xml
)

add_test(NAME test_java_appendAnnotation
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    appendAnnotation
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    appendAnnotation.out.xml
)

add_test(NAME test_java_createExampleSBML
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    createExampleSBML
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    createExampleSBML.out.xml
)

add_test(NAME test_java_echoSBML
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    echoSBML
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    echoSBML.out.xml
)

add_test(NAME test_java_evaluateCustomMath
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    evaluateCustomMath
    2*3+4
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

add_test(NAME test_java_getAllElementsWithNotes
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    getAllElementsWithNotes
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

add_test(NAME test_java_inlineInitialAssignments
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    inlineInitialAssignments
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    inlineInitialAssignments.out.xml
)


add_test(NAME test_java_printAnnotation
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    printAnnotation
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

add_test(NAME test_java_printMath
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    printMath
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

add_test(NAME test_java_printNotes
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    printNotes
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

add_test(NAME test_java_printRegisteredPackages
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    printRegisteredPackages
)

add_test(NAME test_java_printSBML
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    printSBML
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

add_test(NAME test_java_printsupported
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    printsupported
)

add_test(NAME test_java_printUnits
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    printUnits
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

add_test(NAME test_java_promoteParameters
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    promoteParameters
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    promoteParameters.out.xml
)

add_test(NAME test_java_readSBML
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    readSBML
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
)

add_test(NAME test_java_replaceOneFD
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    replaceOneFD
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/functiondef.xml
    f
    reaction_1    
    replaceOneFD.out.xml
)

add_test(NAME test_java_setIdFromNames
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    setIdFromNames
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    setIdFromNames.out.xml
)

 if(ENABLE_FBC) 

add_test(NAME test_java_stripPackage
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    stripPackage
    ${CMAKE_SOURCE_DIR}/examples/sample-models/fbc/fbc_example1.xml
    fbc
    stripPackage.out.xml
)

endif(ENABLE_FBC)

add_test(NAME test_java_unsetAnnotation
    COMMAND ${Java_JAVA_EXECUTABLE} 
    -cp ".${FILE_SEP}${CURRENT_JAR}${FILE_SEP}"
    -Djava.library.path=$<TARGET_FILE_DIR:binding_java_lib>
    unsetAnnotation
    ${CMAKE_SOURCE_DIR}/examples/sample-models/from-spec/level-3/enzymekinetics.xml
    unsetAnnotation.out.xml
)

=== examples/java/multi/CMakeLists.txt ===
## @file    CMakeLists.txt
## @brief   CMake build script for example programs
## @author  Frank T. Bergmann
##
## <!--------------------------------------------------------------------------
## This file is part of libSBML.  Please visit http://sbml.org for more
## information about SBML, and the latest version of libSBML.
##
## Copyright (C) 2013-2018 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##     3. University of Heidelberg, Heidelberg, Germany
##
## Copyright (C) 2009-2013 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##  
## Copyright (C) 2006-2008 by the California Institute of Technology,
##     Pasadena, CA, USA 
##  
## Copyright (C) 2002-2005 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. Japan Science and Technology Agency, Japan
## 
## This library is free software; you can redistribute it and/or modify it
## under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation.  A copy of the license agreement is provided
## in the file named "LICENSE.txt" included with this software distribution
## and also available online as http://sbml.org/software/libsbml/license.html
## ------------------------------------------------------------------------ -->

find_package(Java COMPONENTS Development REQUIRED)

if (JAVA_COMPATIBILITY)
SET(COMPAT_ARGS "-source ${JAVA_COMPATIBILITY} -target ${JAVA_COMPATIBILITY}")
endif()

foreach(file 
		multi_example1
		multi_example2
		multi_example3
		)
	
	file(TO_NATIVE_PATH ${CMAKE_CURRENT_BINARY_DIR} CURRENT_BIN)
	file(TO_NATIVE_PATH ${CMAKE_CURRENT_BINARY_DIR}/../../../src/bindings/java/libsbmlj.jar CURRENT_JAR )
	file(TO_NATIVE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/${file}.java CURRENT_FILE)
		
	add_custom_command(	
		OUTPUT ${file}.class
		COMMAND "${Java_JAVAC_EXECUTABLE}"
		ARGS -cp ".${FILE_SEP}\"${CURRENT_JAR}\"${FILE_SEP}${CMAKE_CURRENT_SOURCE_DIR}"
			 ${CURRENT_FILE}
			 ${COMPAT_ARGS}
			 -d ${CMAKE_CURRENT_BINARY_DIR}
		MAIN_DEPENDENCY "${CMAKE_CURRENT_SOURCE_DIR}/../../../src/bindings/java/local.i"
		WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${file}.java
		COMMENT "Build java example ${file}"
	) 
	
	add_custom_target(example_multi_java_${file} ALL 
		DEPENDS 
		${CMAKE_CURRENT_BINARY_DIR}/${file}.class 
		SOURCES 
		${CMAKE_CURRENT_SOURCE_DIR}/${file}.java 
	)
	
	add_dependencies(example_multi_java_${file} binding_java_jar)
	
endforeach()

if(WITH_JAVA)
# install java examples
file(GLOB java_samples "${CMAKE_CURRENT_SOURCE_DIR}/java/*.java")
install(FILES ${java_samples} DESTINATION ${MISC_PREFIX}examples/java/multi)
endif()

=== examples/java/qual/CMakeLists.txt ===
## @file    CMakeLists.txt
## @brief   CMake build script for example programs
## @author  Frank T. Bergmann
##
## <!--------------------------------------------------------------------------
## This file is part of libSBML.  Please visit http://sbml.org for more
## information about SBML, and the latest version of libSBML.
##
## Copyright (C) 2013-2018 jointly by the following organizations:
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##     3. University of Heidelberg, Heidelberg, Germany
##
## Copyright (C) 2009-2013 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
##  
## Copyright (C) 2006-2008 by the California Institute of Technology,
##     Pasadena, CA, USA 
##  
## Copyright (C) 2002-2005 jointly by the following organizations: 
##     1. California Institute of Technology, Pasadena, CA, USA
##     2. Japan Science and Technology Agency, Japan
## 
## This library is free software; you can redistribute it and/or modify it
## under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation.  A copy of the license agreement is provided
## in the file named "LICENSE.txt" included with this software distribution
## and also available online as http://sbml.org/software/libsbml/license.html
## ------------------------------------------------------------------------ -->

find_package(Java COMPONENTS Development REQUIRED)

if (JAVA_COMPATIBILITY)
SET(COMPAT_ARGS "-source ${JAVA_COMPATIBILITY} -target ${JAVA_COMPATIBILITY}")
endif()

foreach(file 
		qual_example1
		)
	
	file(TO_NATIVE_PATH ${CMAKE_CURRENT_BINARY_DIR} CURRENT_BIN)
	file(TO_NATIVE_PATH ${CMAKE_CURRENT_BINARY_DIR}/../../../src/bindings/java/libsbmlj.jar CURRENT_JAR )
	file(TO_NATIVE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/${file}.java CURRENT_FILE)
		
	add_custom_command(	
		OUTPUT ${file}.class
		COMMAND "${Java_JAVAC_EXECUTABLE}"
		ARGS -cp ".${FILE_SEP}\"${CURRENT_JAR}\"${FILE_SEP}${CMAKE_CURRENT_SOURCE_DIR}"
			 ${CURRENT_FILE}
			 ${COMPAT_ARGS}
			 -d ${CMAKE_CURRENT_BINARY_DIR}
		MAIN_DEPENDENCY "${CMAKE_CURRENT_SOURCE_DIR}/../../../src/bindings/java/local.i"
		WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${file}.java
		COMMENT "Build java example ${file}"
	) 
	
	add_custom_target(example_qual_java_${file} ALL 
		DEPENDS 
		${CMAKE_CURRENT_BINARY_DIR}/${file}.class 
		SOURCES 
		${CMAKE_CURRENT_SOURCE_DIR}/${file}.java 
	)
	
	add_dependencies(example_qual_java_${file} binding_java_jar)
	
endforeach()

if(WITH_JAVA)
# install java examples
file(GLOB java_samples "${CMAKE_CURRENT_SOURCE_DIR}/java/*.java")
install(FILES ${java_samples} DESTINATION ${MISC_PREFIX}examples/java/qual)
endif()

=== src/bindings/csharp/CMakeLists.txt ===
###############################################################################
# Description       : CMake build script for libSBML C# bindings
# Original author(s): Frank Bergmann <fbergman@caltech.edu>
# Organization      : California Institute of Technology
#
# This file is part of libSBML.  Please visit http://sbml.org for more
# information about SBML, and the latest version of libSBML.
#
# Copyright (C) 2013-2018 jointly by the following organizations:
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
#     3. University of Heidelberg, Heidelberg, Germany
#
# Copyright (C) 2009-2013 jointly by the following organizations:
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
#
# Copyright (C) 2006-2008 by the California Institute of Technology,
#     Pasadena, CA, USA
#
# Copyright (C) 2002-2005 jointly by the following organizations:
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. Japan Science and Technology Agency, Japan
#
# This library is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation.  A copy of the license agreement is provided
# in the file named "LICENSE.txt" included with this software distribution
# and also available online as http://sbml.org/software/libsbml/license.html
#
###############################################################################


find_package(SWIG REQUIRED)
find_package(PythonInterp)

include(${SWIG_USE_FILE})

set(LIBSBML_CSHARP_BINDING_NATIVE_LIBRARY_NAME "libsbmlcs" CACHE STRING
                       "The name of the native library file to generate. This can be changed to avoid conflicts with other applications using another version of the library.")
mark_as_advanced(LIBSBML_CSHARP_BINDING_NATIVE_LIBRARY_NAME)


####################################################################
#
# create correct assembly information file
#
configure_file (
  "${CMAKE_CURRENT_SOURCE_DIR}/Properties/AssemblyInfo.cs.in"
  "${CMAKE_CURRENT_BINARY_DIR}/AssemblyInfo.cs"
  )

####################################################################
#
# generate files that include all packages:
#
# - local-downcast-extension.i

file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-extension-*.i")
update_ifile(
   "local-downcast-extension.i" 
   ${CMAKE_CURRENT_BINARY_DIR} 
   "${DOWNCAST_EXTENSION}"
)

# - local-downcast-namespaces.i
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-namespaces-*.i")
update_ifile(
   "local-downcast-namespaces.i" 
   ${CMAKE_CURRENT_BINARY_DIR} 
   "${DOWNCAST_EXTENSION}"
)

# - local-packages.i
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-packages-*.i")
update_ifile(
   "local-packages.i" 
   ${CMAKE_CURRENT_BINARY_DIR} 
   "${DOWNCAST_EXTENSION}"
)

# - local-downcast-converters.i
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-converters-*.i")
update_ifile(
   "local-downcast-converters.i" 
   ${CMAKE_CURRENT_BINARY_DIR} 
   "${DOWNCAST_EXTENSION}"
)

# - local-downcast-astplugins.i
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-astplugins-*.i")
update_ifile(
   "local-downcast-astplugins.i" 
   ${CMAKE_CURRENT_BINARY_DIR} 
   "${DOWNCAST_EXTENSION}"
)


# remove conflicting copies of files, if they exist
foreach(conflict 
 ${CMAKE_CURRENT_SOURCE_DIR}/local-packages.i
 ${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-namespaces.i
 ${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-converters.i
 ${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-extension.i
 ${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-astplugins.i
)
  if (EXISTS ${conflict})
    file(REMOVE ${conflict})
  endif()
endforeach()

####################################################################
#
# determine local dependencies, so as to re-swig if one of them changed
#
file(GLOB SWIG_DEPENDENCIES
	${CMAKE_CURRENT_SOURCE_DIR}/*.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/*.i
	${CMAKE_CURRENT_SOURCE_DIR}/../swig/*.i
	${CMAKE_CURRENT_SOURCE_DIR}/../swig/*.h
	)

#
# Remove SWIG wrappers if requested
#
if (LIBSBML_REMOVE_WRAPPERS)
  foreach(file
    ${CMAKE_CURRENT_BINARY_DIR}/libsbml_wrap.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/csdoc.i
  )
    if (EXISTS ${file})
      FILE(REMOVE ${file})
    endif()
  endforeach()
endif(LIBSBML_REMOVE_WRAPPERS)

####################################################################
#
# SWIG C# bindings
#
set(SWIG_EXTRA_FLAGS)
if(NOT UNIX)
	set(SWIG_EXTRA_FLAGS -DSWIGWIN -DSWIG_CSHARP_NO_WSTRING_HELPER)
endif()

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/swig-binding.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/swig-binding.cmake
	@ONLY
)

if (WITH_DOXYGEN AND NOT EXISTS "${PYTHON_EXECUTABLE}")
  message(FATAL_ERROR 
	"The csharp language bindings require PYTHON_EXECUTABLE to be set 
	 to the python command in order to build documentation."
  )
endif()

# munge argument lists to string, so that they can safely passed along
SET(SWIG_ARGS)
foreach(arg ${SWIG_EXTRA_ARGS} ${SWIG_EXTRA_FLAGS})
if (NOT UNIX)
  set(SWIG_ARGS "${SWIG_ARGS} ${arg}")
else()
  list(APPEND SWIG_ARGS ${arg})
endif()
endforeach()

SET(DOC_ARGS)
foreach(arg ${SWIG_SWIGDOCDEFINES})
if (NOT UNIX)
  set(DOC_ARGS "${DOC_ARGS} ${arg}")
else()
  list(APPEND DOC_ARGS ${arg})
endif()
endforeach()
 
# call a separate script for generating documentation / swiging the output 
add_custom_command(

  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/libsbml_wrap.cpp
	       ${CMAKE_CURRENT_BINARY_DIR}/csharp-files/libsbml.cs
	       ${CMAKE_CURRENT_BINARY_DIR}/csharp-files/libsbmlPINVOKE.cs
	  	   ${CMAKE_CURRENT_BINARY_DIR}/csdoc.i
		   
	COMMAND "${CMAKE_COMMAND}"

	ARGS -DCUR_BIN_DIRECTORY=\"${CMAKE_CURRENT_BINARY_DIR}\"
		 -DBIN_DIRECTORY=\"${LIBSBML_ROOT_BINARY_DIR}\"
		 -DCUR_SRC_DIRECTORY=\"${CMAKE_CURRENT_SOURCE_DIR}\"
		 -DSRC_DIRECTORY=\"${LIBSBML_ROOT_SOURCE_DIR}\"
		 -DCMAKE_COMMAND=\"${CMAKE_COMMAND}\"
		 -DPYTHON_EXECUTABLE=\"${PYTHON_EXECUTABLE}\"
		 -DSWIG_SWIGDOCDEFINES=\"${DOC_ARGS}\"
		 -DSWIG_ARGS=\"${SWIG_ARGS}\"
		 -DSWIG_EXECUTABLE=\"${SWIG_EXECUTABLE}\"
		 -DWITH_DOXYGEN=\"${WITH_DOXYGEN}\"
		 -DLIB_NAME=\"${LIBSBML_CSHARP_BINDING_NATIVE_LIBRARY_NAME}\"
		 -P "${CMAKE_CURRENT_BINARY_DIR}/swig-binding.cmake"
    
  MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/../swig/libsbml.i

	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt
            ${SWIG_DEPENDENCIES} ${LIBSBML_HEADER_FILES}

  COMMENT "Swig C# source"
)

add_custom_target(binding_csharp_swig ALL DEPENDS ${SWIG_DEPENDENCIES})

#
# Determine the csharp installation directory
#
set(CSHAPR_PACKAGE_INSTALL_DIR)
if (UNIX OR CYGWIN)
  set(CSHAPR_PACKAGE_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/mono/libsbmlcsP)
else()
  set(CSHAPR_PACKAGE_INSTALL_DIR ${MISC_PREFIX}bindings/csharp)
endif()

####################################################################
#
# Build native library
#

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../swig)
include_directories(BEFORE ${LIBSBML_ROOT_SOURCE_DIR}/src)
include_directories(BEFORE ${LIBSBML_ROOT_BINARY_DIR}/src)

if (EXTRA_INCLUDE_DIRS) 
 include_directories(${EXTRA_INCLUDE_DIRS})
endif(EXTRA_INCLUDE_DIRS)

add_library(binding_csharp_native_lib SHARED ${CMAKE_CURRENT_BINARY_DIR}/libsbml_wrap.cpp)
add_dependencies(binding_csharp_native_lib binding_csharp_swig)
if (UNIX)
# if name starts with 'lib' drop the prefix, otherwise we get 'liblibXXX'

set(UNIX_NATIVE_NAME "${LIBSBML_CSHARP_BINDING_NATIVE_LIBRARY_NAME}")
string(LENGTH "${LIBSBML_CSHARP_BINDING_NATIVE_LIBRARY_NAME}" length)
if (${length} GREATER 3)
	 string(SUBSTRING "${LIBSBML_CSHARP_BINDING_NATIVE_LIBRARY_NAME}" 0 3 result)
	 if ("${result}" STREQUAL "lib")
	 	   math(EXPR length_minus_three "${length} - 3")
	 	   string(SUBSTRING "${LIBSBML_CSHARP_BINDING_NATIVE_LIBRARY_NAME}" 3 ${length_minus_three} UNIX_NATIVE_NAME)
	 endif()
endif()
set_target_properties (binding_csharp_native_lib PROPERTIES OUTPUT_NAME "${UNIX_NATIVE_NAME}")
else()
set_target_properties (binding_csharp_native_lib PROPERTIES OUTPUT_NAME ${LIBSBML_CSHARP_BINDING_NATIVE_LIBRARY_NAME})
endif()
target_link_libraries(binding_csharp_native_lib ${LIBSBML_LIBRARY}-static)
INSTALL(TARGETS binding_csharp_native_lib
        DESTINATION ${CSHAPR_PACKAGE_INSTALL_DIR}
  )

####################################################################
#
# build managed library
#

add_custom_command(
	OUTPUT
		${CMAKE_CURRENT_BINARY_DIR}/libsbmlcsP.dll
		${CMAKE_CURRENT_BINARY_DIR}/TestRunner.exe
		${CMAKE_CURRENT_BINARY_DIR}/libsbmlcsP.xml
    ${CMAKE_CURRENT_BINARY_DIR}/TestRW.exe

	COMMAND "${CMAKE_COMMAND}"
	ARGS -DCSHARP_EXTRA_ARGS=\"${CSHARP_EXTRA_ARGS}\"
		 -DCSHARP_COMPILER=\"${CSHARP_COMPILER}\"
		 -DBIN_DIRECTORY=\"${CMAKE_CURRENT_BINARY_DIR}\"
		 -DSRC_DIRECTORY=\"${CMAKE_CURRENT_SOURCE_DIR}\"
		 -P "${CMAKE_CURRENT_SOURCE_DIR}/compile-native-files.cmake"

	MAIN_DEPENDENCY "${CMAKE_CURRENT_SOURCE_DIR}/../swig/libsbml.i"
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt
			${CMAKE_CURRENT_SOURCE_DIR}/compile-native-files.cmake
			${CMAKE_CURRENT_BINARY_DIR}/csharp-files/libsbml.cs
	        ${CMAKE_CURRENT_BINARY_DIR}/libsbml_wrap.cpp                
	WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    COMMENT "Build csharp files"
	)

add_custom_target(binding_csharp_managed_lib ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/libsbmlcsP.dll )
add_dependencies(binding_csharp_managed_lib binding_csharp_swig)

INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/libsbmlcsP.dll DESTINATION ${CSHAPR_PACKAGE_INSTALL_DIR})

####################################################################
#
# testing
#

if(WITH_CHECK)


if(UNIX)
	add_test(
	  NAME test_csharp_bindings
	  COMMAND mono
	      ${CMAKE_CURRENT_BINARY_DIR}/TestRW.exe
			  ${LIBSBML_ROOT_SOURCE_DIR}/examples/sample-models/from-spec/level-2/
			  -p $<TARGET_FILE_DIR:binding_csharp_native_lib>)

	# to run the compiled tests
	add_test(
	  NAME test_csharp_bindings_full
      COMMAND mono
			${CMAKE_CURRENT_BINARY_DIR}/TestRunner.exe
			-d ${LIBSBML_ROOT_SOURCE_DIR}/src/sbml/test/test-data
			-l ${CMAKE_CURRENT_BINARY_DIR}/libsbmlcsP.dll
			-w ${CMAKE_CURRENT_SOURCE_DIR}
			-p $<TARGET_FILE_DIR:binding_csharp_native_lib>)
	set_tests_properties(test_csharp_bindings_full PROPERTIES PASS_REGULAR_EXPRESSION "failures 0")

	if(APPLE)
		set_tests_properties(test_csharp_bindings PROPERTIES ENVIRONMENT "DYLD_LIBRARY_PATH=$<TARGET_FILE_DIR:binding_csharp_native_lib>:${CMAKE_CURRENT_BINARY_DIR}:$ENV{DYLD_LIBRARY_PATH}")
		set_tests_properties(test_csharp_bindings_full PROPERTIES ENVIRONMENT "DYLD_LIBRARY_PATH=$<TARGET_FILE_DIR:binding_csharp_native_lib>:${CMAKE_CURRENT_BINARY_DIR}:$ENV{DYLD_LIBRARY_PATH}")
	else()
		set_tests_properties(test_csharp_bindings PROPERTIES ENVIRONMENT "LD_LIBRARY_PATH=$<TARGET_FILE_DIR:binding_csharp_native_lib>:${CMAKE_CURRENT_BINARY_DIR}:$ENV{LD_LIBRARY_PATH}")
		set_tests_properties(test_csharp_bindings_full PROPERTIES ENVIRONMENT "LD_LIBRARY_PATH=$<TARGET_FILE_DIR:binding_csharp_native_lib>:${CMAKE_CURRENT_BINARY_DIR}:$ENV{LD_LIBRARY_PATH}")
	endif()

else()

	include(${LIBSBML_ROOT_SOURCE_DIR}/common.cmake)
	copy_files( ${LIBSBML_ROOT_SOURCE_DIR}/dependencies/bin/ ${CMAKE_CURRENT_BINARY_DIR} *.dll )

	add_test(NAME test_csharp_bindings
		COMMAND ${CMAKE_CURRENT_BINARY_DIR}/TestRW.exe ${LIBSBML_ROOT_SOURCE_DIR}/examples/sample-models/from-spec/level-2/
		-p $<TARGET_FILE_DIR:binding_csharp_native_lib>)

	#  to run the compiled tests
	add_test(NAME test_csharp_bindings_full
			COMMAND ${CMAKE_CURRENT_BINARY_DIR}/TestRunner.exe
			-d ${LIBSBML_ROOT_SOURCE_DIR}/src/sbml/test/test-data

=== src/bindings/matlab/CMakeLists.txt ===
###############################################################################
#
# Description       : CMake build script for libSBML MATLAB bindings
# Original author(s): Frank Bergmann <fbergman@caltech.edu>
# Organization      : California Institute of Technology
#
# This file is part of libSBML.  Please visit http://sbml.org for more
# information about SBML, and the latest version of libSBML.
#
# Copyright (C) 2013-2018 jointly by the following organizations:
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
#     3. University of Heidelberg, Heidelberg, Germany
#
# Copyright (C) 2009-2013 jointly by the following organizations: 
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
#  
# Copyright (C) 2006-2008 by the California Institute of Technology,
#     Pasadena, CA, USA 
#  
# Copyright (C) 2002-2005 jointly by the following organizations: 
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. Japan Science and Technology Agency, Japan
# 
# This library is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation.  A copy of the license agreement is provided
# in the file named "LICENSE.txt" included with this software distribution
# and also available online as http://sbml.org/software/libsbml/license.html
#
###############################################################################

if(WITH_MATLAB)
SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}" ${CMAKE_MODULE_PATH}) 
find_package(Matlab)

# on windows let us build the library using MSVC, on Linux and OS X we choose
# to build with the buildSBML script by default
#set(MATLAB_MEX_DEFAULT)
#set(WITH_MATLAB_BUILDSBML_DEFAULT)
#if (UNIX)
#   set(WITH_MATLAB_BUILDSBML_DEFAULT ON)
#   set(MATLAB_MEX_DEFAULT OFF)
#else()
#   set(WITH_MATLAB_BUILDSBML_DEFAULT OFF)
#   set(MATLAB_MEX_DEFAULT OFF)
#endif()
#
#option(WITH_MATLAB_BUILDSBML   
#      "Generate Matlab bindings using the buildsbml script from matlab."     ${WITH_MATLAB_BUILDSBML_DEFAULT} )
#option(WITH_MATLAB_MEX   
#      "Generate Matlab bindings using MEX compiler "     ${MATLAB_MEX_DEFAULT} )


# 
# Determine the matlab installation directory
#
set(MATLAB_PACKAGE_INSTALL_DIR)
if (UNIX OR CYGWIN) 
  set(MATLAB_PACKAGE_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR})
else()
  set(MATLAB_PACKAGE_INSTALL_DIR ${MISC_PREFIX}bindings/matlab)
endif()


	if (MSVC)
	###############################################################################
	#
	# this is a directory level operation!
	#
	if (WITH_STATIC_RUNTIME)
		foreach(flag_var
			CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
			CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO
			CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
			CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
	
			if(${flag_var} MATCHES "/MD")
				string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
			endif(${flag_var} MATCHES "/MD")
			
			
		endforeach(flag_var)
		add_definitions( -D_MT)
	endif(WITH_STATIC_RUNTIME)
	endif()
	
	include_directories(${MATLAB_INCLUDE_DIR})
	include_directories(BEFORE ${LIBSBML_ROOT_BINARY_DIR}/src)

	if (EXTRA_INCLUDE_DIRS) 
	  include_directories(${EXTRA_INCLUDE_DIRS})
	endif(EXTRA_INCLUDE_DIRS)

	SET(COMMON_FILES
		"${CMAKE_CURRENT_SOURCE_DIR}/ModelDetails.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/StructureFields.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/CommonFunctions.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Filenames.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/InputOutput.cpp"	)
	
	foreach(matlab_source_file "TranslateSBML" "OutputSBML")
	
		add_library(matlab_binding_${matlab_source_file} SHARED "${CMAKE_CURRENT_SOURCE_DIR}/${matlab_source_file}.cpp" ${COMMON_FILES})
		set_target_properties(matlab_binding_${matlab_source_file} PROPERTIES OUTPUT_NAME "${matlab_source_file}")
		set_target_properties(matlab_binding_${matlab_source_file} PROPERTIES SUFFIX ".${MATLAB_MEX_EXT}")
                set_target_properties(matlab_binding_${matlab_source_file} PROPERTIES  PREFIX "")
		if (MSVC)
		set_target_properties(matlab_binding_${matlab_source_file} PROPERTIES LINK_FLAGS "/export:mexFunction") 
		endif()
		target_link_libraries(matlab_binding_${matlab_source_file} ${MATLAB_LIBRARIES} ${LIBSBML_LIBRARY}-static)				
		install(TARGETS matlab_binding_${matlab_source_file} DESTINATION ${MATLAB_PACKAGE_INSTALL_DIR} )

	endforeach()
	
	
#endif(WITH_MATLAB_BUILDSBML)


# mark files for installation
file(GLOB matlab_scripts "${CMAKE_CURRENT_SOURCE_DIR}/../matlab/*.m"
                         "${CMAKE_CURRENT_SOURCE_DIR}/../matlab/*.xml")
install(FILES ${matlab_scripts} DESTINATION ${MATLAB_PACKAGE_INSTALL_DIR})

# add test cases
if (WITH_CHECK)
	
	add_subdirectory(test)	

endif()


endif()

=== src/bindings/octave/CMakeLists.txt ===
###############################################################################
#
# Description       : CMake build script for libSBML Octave bindings
# Original author(s): Frank Bergmann <fbergman@caltech.edu>
# Organization      : California Institute of Technology
#
# This file is part of libSBML.  Please visit http://sbml.org for more
# information about SBML, and the latest version of libSBML.
#
# Copyright (C) 2013-2018 jointly by the following organizations:
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
#     3. University of Heidelberg, Heidelberg, Germany
#
# Copyright (C) 2009-2013 jointly by the following organizations: 
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
#  
# Copyright (C) 2006-2008 by the California Institute of Technology,
#     Pasadena, CA, USA 
#  
# Copyright (C) 2002-2005 jointly by the following organizations: 
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. Japan Science and Technology Agency, Japan
# 
# This library is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation.  A copy of the license agreement is provided
# in the file named "LICENSE.txt" included with this software distribution
# and also available online as http://sbml.org/software/libsbml/license.html
#
###############################################################################

if(WITH_OCTAVE)
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}")
find_package(Octave)

if (NOT EXISTS "${MKOCTFILE_EXECUTABLE}")
	# fail if mkoctfile was not found
	message (FATAL_ERROR "The mkoctfile command is vital for building octave bindings. It was not found during configuration. Please manually specify MKOCTFILE_EXECUTABLE.")
endif()


# get location of library
set(sbml_location $<TARGET_LINKER_FILE:${LIBSBML_LIBRARY}>)
set(sbml_path $<TARGET_FILE_DIR:${LIBSBML_LIBRARY}>)

# break up the libsbml library dependencies into paths and libraries
set(OCTAVE_EXTRA_LIBS)
set(OCTAVE_EXTRA_PATHS)
if (UNIX)
foreach(lib ${LIBSBML_LIBS})

  string(FIND "${lib}" "::" index)

  if (index GREATER 0)
    # found dependent library
    set(name $<TARGET_LINKER_FILE_BASE_NAME:${lib}>)
    set(path $<TARGET_FILE_DIR:${lib}>)
  else()
    get_filename_component(name ${lib} NAME_WE)
    get_filename_component(path ${lib} PATH)
    string(REGEX REPLACE "lib" "" name "${name}")
  endif()

  string(FIND "${name}" "::" index)

  if (index EQUAL -1)

    list(APPEND OCTAVE_EXTRA_LIBS -l${name})
    list(APPEND OCTAVE_EXTRA_PATHS -L${path})

  endif()
endforeach()
endif()

# 
# Determine the octave installation directory
#
set(OCTAVE_PACKAGE_INSTALL_DIR)
if (UNIX OR CYGWIN) 
execute_process(COMMAND "${OCTAVE_CONFIG_EXECUTABLE}" -p CANONICAL_HOST_TYPE
    OUTPUT_VARIABLE OCTAVE_PLATFORM OUTPUT_STRIP_TRAILING_WHITESPACE)
  set(OCTAVE_PACKAGE_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/octave/site/oct/${OCTAVE_PLATFORM})
else()
  set(OCTAVE_PACKAGE_INSTALL_DIR ${MISC_PREFIX}bindings/octave)
endif()

SET(COMMON_FILES
  "${CMAKE_CURRENT_SOURCE_DIR}/../matlab/ModelDetails.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/../matlab/StructureFields.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/../matlab/CommonFunctions.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/../matlab/Filenames.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/../matlab/InputOutput.cpp"	)	

macro(build_octave_file fileName)
	# compile and link mex file
	ADD_CUSTOM_COMMAND(	
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${fileName}.mex
		COMMAND "${CMAKE_COMMAND}"
		ARGS  -E remove ${CMAKE_CURRENT_BINARY_DIR}/${fileName}.mex
		COMMAND "${MKOCTFILE_EXECUTABLE}"
		ARGS 
			-o ${CMAKE_CURRENT_BINARY_DIR}/${fileName}.mex
			--mex
			-DUSE_OCTAVE		 
			-I${CMAKE_CURRENT_BINARY_DIR}/../../
			-I${CMAKE_CURRENT_SOURCE_DIR}/../../
			-I${LIBSBML_ROOT_SOURCE_DIR}/include
			${CMAKE_CURRENT_SOURCE_DIR}/../matlab/${fileName}.cpp
			${COMMON_FILES}
			-l${LIBSBML_LIBRARY}
			${OCTAVE_EXTRA_LIBS}
			${OCTAVE_EXTRA_PATHS}
			-L${sbml_path}
	
		MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/../matlab/${fileName}.cpp
		COMMENT "compile and link octave mex file: ${fileName}") 
	
	add_custom_target(binding_octave_${fileName} ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${fileName}.mex ${LIBSBML_LIBRARY})
	add_dependencies(binding_octave_${fileName} ${LIBSBML_LIBRARY})
	
	# mark files
	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${fileName}.mex DESTINATION ${OCTAVE_PACKAGE_INSTALL_DIR} )

endmacro()

build_octave_file("TranslateSBML")
build_octave_file("OutputSBML")


foreach(mFile
  test.xml
  addLevelVersion.m
  applyUserValidation.m
  CheckAndConvert.m
  Contents.m
  ConvertFormulaToMathML.m
  getDefaultValues.m
  getSBMLDefaultStruct.m
  getStructure.m
  getStructureEnum.m
  getStructureFieldnames.m
  getValueType.m
  installSBML.m
  isEnabled.m
  isFbcEnabled.m
  isoctave.m
  isSBML_Model.m
  OutputSBML.m
  TranslateSBML.m
)

	install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/../matlab/${mFile} DESTINATION ${OCTAVE_PACKAGE_INSTALL_DIR} )

endforeach()

# add test files

foreach(testfiles
  compareFiles.m
  runTests.m
  testBinding.m
  testCVTerms.m
  testGetSBMLDefaultStruct.m
  testIsSBMLModel.m
  testMissingOutput.m
  testOutput.m
  testReadFlags.m
  testReadFromFile1.m
  testReadFromFile10.m
  testReadFromFile11.m
  testReadFromFile12.m
  testReadFromFile13.m
  testReadFromFile14.m
  testReadFromFile15.m
  testReadFromFile16.m
  testReadFromFile2.m
  testReadFromFile3.m
  testReadFromFile4.m
  testReadFromFile5.m
  testReadFromFile6.m
  testReadFromFile7.m
  testReadFromFile8.m
  testReadFromFile9.m
  testReadFromFileFbc1.m
  testReadFromFileFbc2.m
  testReadWriteGeneProductIds.m
  testReadWriteGeneProducts.m
  testVersionInformation.m)

	install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/../matlab/test/${testfiles} DESTINATION ${OCTAVE_PACKAGE_INSTALL_DIR}/test )

endforeach()

foreach(testxmlfiles
algebraicRules.xml
both.xml
convertedFormulas.xml
convertedFormulas2.xml
convertedFormulasL2.xml
createdAnnotation.xml
createdAnnotationL2.xml
csymbolAvogadro.xml
csymbolDelay.xml
csymbolTime-reaction-l2.xml
csymbolTime.xml
errors.xml
fatal.xml
fbc.xml
fbcL3V2V1.xml
fbcL3V2V2.xml
fbcV2.xml
fbcV2Labels.xml
fbc_groups.xml
fbc_qual.xml
fbc_qual_groups.xml
funcDefsWithInitialAssignments.xml
functionDefinition.xml
groups-example1.xml
groups_qual.xml
initialAssignments.xml
l1v1-branch.xml
l1v1-minimal.xml
l1v1-rules.xml
l1v1-units.xml
l1v1.xml
l1v2-all.xml
l2v1-all.xml
l2v1-allelements.xml
l2v1-assignment.xml
l2v2-all.xml
l2v2-newComponents.xml
l2v2-newelements.xml
l2v3-all.xml
l2v3-newelements.xml
l2v3-newMath.xml
l2v4-all.xml
l2v5-all.xml
l3v1core.xml
l3v2-empty-event.xml
l3v2-empty-math.xml
l3v2-newmath.xml
l3v2-no-model.xml
l3v2core.xml
math_no_arguments.xml
missing_out.xml
nestedPiecewise.xml
none.xml
nonLogicals.xml
notes_annotations.xml
outGP00.xml
outGP01.xml
outGP10.xml
outGP11.xml
piecewise.xml
qual.xml
rateRules.xml
readerror.xml
sparseStoichiometry.xml
species.xml
test-greek.xml
warn.xml
)

	install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/../matlab/test/test-data/${testxmlfiles} DESTINATION ${OCTAVE_PACKAGE_INSTALL_DIR}/test/test-data )

endforeach()


endif()

=== src/bindings/python/CMakeLists.txt ===
###############################################################################
#
# Description       : CMake build script for libSBML Python bindings
# Original author(s): Frank Bergmann <fbergman@caltech.edu>
# Organization      : California Institute of Technology
#
# This file is part of libSBML.  Please visit http://sbml.org for more
# information about SBML, and the latest version of libSBML.
#
# Copyright (C) 2013-2018 jointly by the following organizations:
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
#     3. University of Heidelberg, Heidelberg, Germany
#
# Copyright (C) 2009-2013 jointly by the following organizations: 
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
#  
# Copyright (C) 2006-2008 by the California Institute of Technology,
#     Pasadena, CA, USA 
#  
# Copyright (C) 2002-2005 jointly by the following organizations: 
#     1. California Institute of Technology, Pasadena, CA, USA
#     2. Japan Science and Technology Agency, Japan
# 
# This library is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation.  A copy of the license agreement is provided
# in the file named "LICENSE.txt" included with this software distribution
# and also available online as http://sbml.org/software/libsbml/license.html
#
###############################################################################

find_package(SWIG REQUIRED)
include(${SWIG_USE_FILE})
find_package(PythonInterp)

# specify that the same python library should be found 
# as the one the selected interpreter uses
set (Python_ADDITIONAL_VERSIONS ${PYTHON_VERSION_STRING})
find_package(PythonLibs)


####################################################################
#
# determine local dependencies, so as to re-swig if one of them changed
# 

file(GLOB SWIG_DEPENDENCIES 
    ${CMAKE_CURRENT_SOURCE_DIR}/*.i 
    ${CMAKE_CURRENT_SOURCE_DIR}/*.h 
    ${CMAKE_CURRENT_SOURCE_DIR}/*.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/*.cmake
    ${CMAKE_CURRENT_SOURCE_DIR}/../swig/*.i
    ${CMAKE_CURRENT_SOURCE_DIR}/../swig/*.h
    )


####################################################################
#
# generate files that include all packages: 
#


# - local-packages.i
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-*.i")
list(REMOVE_ITEM DOWNCAST_EXTENSION "local-packages.i")
# - local-packages.i
update_ifile(
    "local-packages.i" 
    ${CMAKE_CURRENT_BINARY_DIR} 
    "${DOWNCAST_EXTENSION}"
)

# - local-downcast.cpp
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-packages-*.cpp")
update_cfile(
    "local-downcast.cpp" 
    ${CMAKE_CURRENT_BINARY_DIR} 
    "${DOWNCAST_EXTENSION}"
)

# - local-downcast-extension.cpp
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-extension-*.cpp")
update_cfile(
    "local-downcast-extension.cpp" 
    ${CMAKE_CURRENT_BINARY_DIR} 
    "${DOWNCAST_EXTENSION}" 
)

# - local-downcast-namespaces.cpp
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-namespaces-*.cpp")
update_cfile(
    "local-downcast-namespaces.cpp" 
    ${CMAKE_CURRENT_BINARY_DIR} 
    "${DOWNCAST_EXTENSION}"
)

# - local-downcast-plugins.cpp
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-plugins-*.cpp")
update_cfile(
    "local-downcast-plugins.cpp" 
    ${CMAKE_CURRENT_BINARY_DIR} 
    "${DOWNCAST_EXTENSION}"
)

# - local-downcast-plugins.cpp
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-astplugins-*.cpp")
update_cfile(
    "local-downcast-astplugins.cpp" 
    ${CMAKE_CURRENT_BINARY_DIR} 
    "${DOWNCAST_EXTENSION}"
)

# - local-downcast-converters.cpp
file(GLOB DOWNCAST_EXTENSION RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/local-downcast-converters-*.cpp")
update_cfile(
    "local-downcast-converters.cpp" 
    ${CMAKE_CURRENT_BINARY_DIR} 
    "${DOWNCAST_EXTENSION}"
)

#
# Remove SWIG wrappers if requested
#
if (LIBSBML_REMOVE_WRAPPERS)
    foreach(file 
        ${CMAKE_CURRENT_BINARY_DIR}/libsbml_wrap.cpp
        ${CMAKE_CURRENT_BINARY_DIR}/pydoc-normal.i
        ${CMAKE_CURRENT_BINARY_DIR}/pydoc-doxygen.i
    )
        if (EXISTS ${file})
            FILE(REMOVE ${file})
        endif()
    endforeach()
endif(LIBSBML_REMOVE_WRAPPERS)

# the Python bindings will only build if some files are generated, 
# for those files to be generated the following python scripts are 
# needed
file(COPY 
    ${CMAKE_CURRENT_SOURCE_DIR}/../swig/libsbmlutils.py  
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../docs/src/utilities/generate-class-name-list.py"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../docs/src/utilities/generate-converters-list.py"
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR})


# Normally in Python 2 only ascii strings are accepted as input to 
# libSBML functions SWIG >= 3.0.8 allows one to change this behaviour
# such that both ascii and utf-8 strings can be input. This enables
# this behaviour or prints a warning if Swig version is too old.
if (SWIG_FOUND AND PYTHON_VERSION_STRING VERSION_LESS 3.0)
  if (SWIG_VERSION VERSION_GREATER "3.0.7")
    list(APPEND SWIG_EXTRA_ARGS -DUSE_SWIG_PYTHON_2_UNICODE)
    # message(STATUS SWIG_VERSION "${SWIG_VERSION}")
  else()
    message(WARNING 
"Python ${PYTHON_VERSION_STRING} detected and SWIG version ${SWIG_VERSION}
 < 3.0.8, I cannot enable SWIG_PYTHON_2_UNICODE libSBML Python 
 bindings only accept strings as arugments. Please upgrade Swig to a
 version greater than 3.0.8 to enable unicode input in Python 2. See 
 http://www.swig.org/Doc3.0/Python.html for more details.)")
  endif()
endif()

####################################################################
#
# Swig bindings
#
#
add_custom_command(  

    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/libsbml_wrap.cpp
        ${CMAKE_CURRENT_BINARY_DIR}/libsbml.py
        ${CMAKE_CURRENT_BINARY_DIR}/class-list.txt
        ${CMAKE_CURRENT_BINARY_DIR}/libsbml-converters.txt

    COMMAND "${PYTHON_EXECUTABLE}"
    ARGS  "${CMAKE_CURRENT_SOURCE_DIR}/../swig/swigdoc.py"
        --language python
        --top "${LIBSBML_ROOT_SOURCE_DIR}"
        --master "${CMAKE_CURRENT_SOURCE_DIR}/../swig/libsbml.i"
        --output "${CMAKE_CURRENT_BINARY_DIR}/pydoc-doxygen.i"
        ${SWIG_SWIGDOCDEFINES}

    COMMAND "${PYTHON_EXECUTABLE}"
    ARGS  "${CMAKE_CURRENT_BINARY_DIR}/generate-class-name-list.py"
        "${LIBSBML_ROOT_SOURCE_DIR}/src"
        >
        "${CMAKE_CURRENT_BINARY_DIR}/class-list.txt"

    COMMAND "${PYTHON_EXECUTABLE}"
    ARGS  "${CMAKE_CURRENT_BINARY_DIR}/generate-converters-list.py"  
        "${CMAKE_CURRENT_BINARY_DIR}/class-list.txt"
        >
        "${CMAKE_CURRENT_BINARY_DIR}/libsbml-converters.txt"

    COMMAND "${PYTHON_EXECUTABLE}"
    ARGS  "${CMAKE_CURRENT_SOURCE_DIR}/doc-converter/rewrite_pydoc.py"
        -f "${CMAKE_CURRENT_BINARY_DIR}/pydoc-doxygen.i"
        -o "${CMAKE_CURRENT_BINARY_DIR}/pydoc-normal.i"
        -i ${CMAKE_CURRENT_SOURCE_DIR}/../../../docs/src/common-text
        -g ${CMAKE_CURRENT_SOURCE_DIR}/../../../docs/src/common-graphics

    COMMAND "${CMAKE_COMMAND}"
    ARGS  -E rename pydoc-doxygen.i pydoc.i

    COMMAND "${SWIG_EXECUTABLE}"
    ARGS  -I${CMAKE_CURRENT_SOURCE_DIR}/../swig/
        -I${CMAKE_CURRENT_SOURCE_DIR} 
        -I${CMAKE_CURRENT_BINARY_DIR} 
        -I${LIBSBML_ROOT_BINARY_DIR}/src
        -I${LIBSBML_ROOT_SOURCE_DIR}/src
        -I${LIBSBML_ROOT_SOURCE_DIR}/include
        -DGENERATING_DOCS
        -c++
        -python    
        ${SWIG_EXTRA_ARGS}     
        -o ${CMAKE_CURRENT_BINARY_DIR}/libsbml_wrap.cpp 
        ${CMAKE_CURRENT_SOURCE_DIR}/libsbml.i

    COMMAND "${CMAKE_COMMAND}"
    ARGS  -E rename pydoc.i pydoc-doxygen.i

    COMMAND "${CMAKE_COMMAND}"
    ARGS  -E rename libsbml.py libsbml-doxygen.py

    COMMAND "${CMAKE_COMMAND}"
    ARGS  -E rename pydoc-normal.i pydoc.i

    COMMAND "${SWIG_EXECUTABLE}"
    ARGS  -I${CMAKE_CURRENT_SOURCE_DIR}/../swig/
        -I${CMAKE_CURRENT_SOURCE_DIR} 
        -I${CMAKE_CURRENT_BINARY_DIR} 
        -I${LIBSBML_ROOT_BINARY_DIR}/src
        -I${LIBSBML_ROOT_SOURCE_DIR}/src
        -I${LIBSBML_ROOT_SOURCE_DIR}/include
        -c++
        -python    
        ${SWIG_EXTRA_ARGS}     
        -o ${CMAKE_CURRENT_BINARY_DIR}/libsbml_wrap.cpp 
        ${CMAKE_CURRENT_SOURCE_DIR}/libsbml.i

    COMMAND "${CMAKE_COMMAND}"
    ARGS  -E rename pydoc.i pydoc-normal.i 

    COMMAND "${CMAKE_COMMAND}"
    ARGS -DCUR_BIN_DIRECTORY=\"${CMAKE_CURRENT_BINARY_DIR}\"
         -DVERSION=\"${LIBSBML_DOTTED_VERSION}\"
         -P "${CMAKE_CURRENT_SOURCE_DIR}/add_version.cmake"

    COMMAND "${CMAKE_COMMAND}"
    ARGS -DBIN_DIRECTORY=\"${CMAKE_CURRENT_BINARY_DIR}\"
         -DSRC_DIRECTORY=\"${CMAKE_CURRENT_SOURCE_DIR}\"
         -DPYTHON_USE_API2_WARNINGS=\"${PYTHON_USE_API2_WARNINGS}\"
         -P "${CMAKE_CURRENT_SOURCE_DIR}/patch-python.cmake"

    MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/libsbml.i
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/doc-converter/rewrite_pydoc.py
        ${CMAKE_CURRENT_SOURCE_DIR}/../swig/swigdoc.py
        ${SWIG_DEPENDENCIES} ${LIBSBML_HEADER_FILES}

    COMMENT "Swig Python source") 

add_custom_target(binding_python_swig ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/libsbml_wrap.cpp )

####################################################################
#
# Build native library
#


include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../swig)
include_directories(${LIBSBML_ROOT_SOURCE_DIR}/include)
include_directories(${PYTHON_INCLUDE_DIRS})
include_directories(BEFORE ${LIBSBML_ROOT_BINARY_DIR}/src)
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR})

if (EXTRA_INCLUDE_DIRS) 
    include_directories(${EXTRA_INCLUDE_DIRS})
endif(EXTRA_INCLUDE_DIRS)

if (MSVC)
    # the build fails when compiled with packages as the object file is too 
    # big adding the big flag makes it work!
    add_definitions(/bigobj)
endif(MSVC)

add_library(binding_python_lib SHARED libsbml_wrap.cpp)
add_dependencies( binding_python_lib binding_python_swig) 

set_target_properties (binding_python_lib PROPERTIES OUTPUT_NAME "_libsbml")
if (UNIX)
    set_target_properties (binding_python_lib PROPERTIES PREFIX "")
    set_target_properties (binding_python_lib PROPERTIES SUFFIX ".so")
else()    
    if (CYGWIN)
        set_target_properties (binding_python_lib PROPERTIES PREFIX "")
        set_target_properties (binding_python_lib PROPERTIES SUFFIX ".dll")
    else()
        set_target_properties (binding_python_lib PROPERTIES SUFFIX ".pyd")  
    endif()
endif()

if(APPLE OR UNIX)
    option (PYTHON_USE_DYNAMIC_LOOKUP
    "Do not actually link against the python library, instead use the undefined lookup mechanism, that ." OFF)
    mark_as_advanced(PYTHON_USE_DYNAMIC_LOOKUP)
endif(APPLE OR UNIX)

if (PYTHON_USE_DYNAMIC_LOOKUP)
    if (APPLE)
        set_target_properties (binding_python_lib PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
    endif()
    target_link_libraries(binding_python_lib ${LIBSBML_LIBRARY}-static)
else()                                          
    target_link_libraries(binding_python_lib ${LIBSBML_LIBRARY}-static ${PYTHON_LIBRARIES})
endif()


# 
# Determine the python installation directory
#
set(PYTHON_PACKAGE_INSTALL_DIR)
if (UNIX OR CYGWIN OR MINGW)
    execute_process(COMMAND "${PYTHON_EXECUTABLE}" -c "import sys; sys.stdout.write('{}.{}'.format(*sys.version_info[:2]))"
        OUTPUT_VARIABLE PYTHON_VERSION)

=== src/bindings/python/doc-converter/Makefile ===
check:
	env PYTHONPATH=`pwd` test/run.py

=== debian/changelog ===
libsbml (5.19.7+dfsg-2) unstable; urgency=medium

  * Team upload.
  * d/control: bump preferred python3 version to 3.11. (Closes: #1028993)
  * d/control: declare compliance to standards version 4.6.2.

 -- Étienne Mollier <emollier@debian.org>  Mon, 16 Jan 2023 21:48:17 +0100

libsbml (5.19.7+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Upstream moved to Github
  * New upstream version
  * Install octave tests and cmake files
  * Remove Windows related file from upstream source
  * Just provide default Python3 version support since upstream
    does not support more than one Python3 version and adjust
    python3-sbml5.install
  * lintian-overrides (see lintian bug #1017966)
  * X-Python3-Version: 3.10

  [ Pierre Gruet ]
  * Fixing a wrong import in AutoTestRunner.java
  * Fixing a missing import in the matlab bindings

  [ Étienne Mollier ]
  * d/t/autopkgtest-pkg-python.conf: invoke module as "libsbml".
  * d/control: enable testsuite autopkgtest-pkg-python.

 -- Andreas Tille <tille@debian.org>  Fri, 02 Dec 2022 10:53:13 +0100

libsbml (5.19.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Setting javac source/target level to 7 to be able to build with OpenJDK 17
    (Closes: #1011157)
  * Standards-Version: 4.6.1 (routine-update)
  * Set upstream metadata fields: Archive, Repository.

 -- Pierre Gruet <pgt@debian.org>  Sun, 29 May 2022 20:33:42 +0200

libsbml (5.19.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Add python3.10.patch from Frank T. Bergmann to fix FTBFS with python3.10.
    Thanks to Adrian Bunk (Closes: #1008669)
  * Standards-Version: 4.6.0 (routine-update)

 -- Étienne Mollier <emollier@debian.org>  Wed, 30 Mar 2022 22:25:04 +0200

=== debian/control ===
Source: libsbml
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ivo Maintz <ivo@maintz.de>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               cmake,
               dh-exec,
               doxygen,
               swig,
               libxml2-dev,
               python3-dev,
# should be python3-all-dev but build system can only deal with one Python interpreter
               perl,
               libperl-dev,
               default-jdk-headless,
               default-jdk-doc,
               dh-octave,
               r-base-dev,
               r-base-core,
               graphviz,
               zlib1g-dev,
               libbz2-dev,
               libnewlib-dev,
               check,
               mono-devel,
               mono-mcs,
               cli-common-dev,
               mono-runtime-common,
               texlive-latex-base,
               rdfind,
               texlive-latex-extra
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/libsbml
Vcs-Git: https://salsa.debian.org/med-team/libsbml.git
Homepage: http://www.sbml.org/
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-python
X-Python3-Version: 3.11

Package: libsbml5-dev
Architecture: any-amd64 arm64 armel armhf any-i386 mips64el ppc64el s390x ia64 ppc64 riscv64 sh4 sparc64 x32
Section: libdevel
Depends: libsbml5 (= ${binary:Version}),
         ${misc:Depends}
Provides: libsbml-dev
Description: System Biology Markup Language library - development files
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains files necessary for development with libsbml.

Package: libsbml5
Architecture: any-amd64 arm64 armel armhf any-i386 mips64el ppc64el s390x ia64 ppc64 riscv64 sh4 sparc64 x32
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Provides: libsbml
Multi-Arch: same
Description: System Biology Markup Language library
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.

Package: python3-sbml5
Architecture: any-amd64 arm64 armel armhf any-i386 mips64el ppc64el s390x ia64 ppc64 riscv64 sh4 sparc64 x32
Section: python
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends},
         swig
Provides: python3-sbml
Description: System Biology Markup Language library - Python3 bindings
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains the Python3 bindings of LibSBML.

Package: libsbml5-java
Architecture: any-amd64 arm64 armel armhf any-i386 mips64el ppc64el s390x ia64 ppc64 riscv64 sh4 sparc64 x32
Section: java
Depends: ${shlibs:Depends},
         ${misc:Depends},
         jarwrapper,
         default-jdk-doc
Pre-Depends: ${misc:Pre-Depends}
Provides: libsbml-java
Description: System Biology Markup Language library - Java bindings
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This Package contains the Java bindings of LibSBML.

Package: libsbml5-perl
Architecture: any-amd64 arm64 armel armhf any-i386 mips64el ppc64el s390x ia64 ppc64 riscv64 sh4 sparc64 x32
Section: perl
Depends: ${shlibs:Depends},
         ${perl:Depends},
         ${misc:Depends}
Provides: libsbml-perl
Description: System Biology Markup Language library - Perl bindings
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains the Perl bindings of LibSBML.

Package: libsbml5-octave
Architecture: any-amd64 arm64 armel armhf any-i386 mips64el ppc64el s390x ia64 ppc64 riscv64 sh4 sparc64 x32
Section: math
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${octave:Depends}
Provides: libsbml-octave
Description: System Biology Markup Language library - Octave bindings
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains the Octave bindings of LibSBML.

Package: libsbml5-cil
Architecture: any-amd64 arm64 armel armhf any-i386 mips64el ppc64el s390x ia64 ppc64 riscv64 sh4 sparc64 x32
Section: cli-mono
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${cli:Depends},
         libsbml5-dev
Provides: libsbml-cil
Description: System Biology Markup Language library - CLI bindings
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains the CLI bindings of LibSBML.

Package: libsbml5-examples
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: libsbml5-dev (= ${binary:Version})
Description: System Biology Markup Language library -- example files
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains C/C++, Java, Perl and layout examples.

Package: libsbml5-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: libsbml5-dev (= ${binary:Version})
Description: System Biology Markup Language library -- documentation
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains C/C++ documentation.

Package: libsbml5-cil-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: libsbml5-dev (= ${binary:Version})
Description: System Biology Markup Language library -- CLI documentation
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains documentation for Mono/CLI bindings

Package: libsbml5-perl-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libsbml5-dev (= ${binary:Version})
Multi-Arch: foreign
Description: System Biology Markup Language library -- Perl documentation
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains documentation for Perl bindings

Package: python3-sbml5-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: libsbml5-dev (= ${binary:Version})
Description: System Biology Markup Language library - Python3 documentation
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 .
 This package contains documentation for Python3 bindings

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/sbmlteam/libsbml/tags (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
